<?php
/**
* The worldnet_hpp class, containing the payment processing code
* for transactions with WorldNet's Hosted Payment Page
*
* @copyright Copyright (C) 2010 WorldNet TPS - All rights reserved.
*/

$nzshpcrt_gateways[$num]['name'] = 'WorldNet HPP secure payments';
$nzshpcrt_gateways[$num]['internalname'] = 'worldnet_hpp';
$nzshpcrt_gateways[$num]['function'] = 'gateway_worldnet_hpp';
$nzshpcrt_gateways[$num]['form'] = 'form_worldnet_hpp';
$nzshpcrt_gateways[$num]['submit_function'] = 'submit_worldnet_hpp';

function form_worldnet_hpp() {
	$gateways = array("WorldNet" => "payments", "CashFlows" => "cashflows");
	$baseCurrencies = array("Euros" => "EUR", "Sterling" => "GBP", "US Dollars" => "USD");
	
	$gatewayString = "";
	foreach($gateways as $name => $code) $gatewayString .= '<option value="' . $code . '"' . ($code == get_option('worldnet_hpp_gateway') ? ' selected="selected"' : '') . '>' . $name . '</option>';
	
	$baseCurrencyStringOne = "";
	foreach($baseCurrencies as $name => $code) $baseCurrencyStringOne .= '<option value="' . $code . '"' . ($code == get_option('worldnet_hpp_terminal_currency_1') ? ' selected="selected"' : '') . '>' . $name . '</option>';
	
	$output  = '<tr><td>Gateway:</td><td><select name="worldnet_hpp_gateway">' . $gatewayString . '</select></td></tr>';
	$output .= '<tr><td>Test account?</td><td><input name="worldnet_hpp_test_account" type="checkbox" ' . (get_option('worldnet_hpp_test_account') ? 'checked="checked"' : '') . '/></td></tr>';
	$output .= '<tr><td>Terminal ID:</td><td><input name="worldnet_hpp_terminal_id_1" type="text" value="' . get_option('worldnet_hpp_terminal_id_1') . '" /></td></tr>';
	$output .= '<tr><td>Terminal Currency:</td><td><select name="worldnet_hpp_terminal_currency_1">' . $baseCurrencyStringOne . '</select></td></tr>';
	$output .= '<tr><td>Shared Secret:</td><td><input name="worldnet_hpp_shared_secret_1" type="text" value="' . get_option('worldnet_hpp_shared_secret_1') . '" /></td></tr>';
	$output .= '<tr><td>Send receipt?</td><td><input name="worldnet_hpp_send_email" type="checkbox" ' . (get_option('worldnet_hpp_send_email') ? 'checked="checked" ' : '') . '/></td></tr>';
	$output .= '<tr><td colspan="2"><span class="wpscsmall description">If checked, WorldNet will send a payment receipt to the cardholders email address. This receipt is a payment receipt only, and will not contain any order details.</span></td></tr>';
	
	return $output;
}

function submit_worldnet_hpp() {
	update_option('worldnet_hpp_gateway', $_POST['worldnet_hpp_gateway']);
	
	if(isset($_POST['worldnet_hpp_test_account'])) update_option('worldnet_hpp_test_account', true);
	else update_option('worldnet_hpp_test_account', false);
	
	update_option('worldnet_hpp_terminal_id_1', $_POST['worldnet_hpp_terminal_id_1']);
	update_option('worldnet_hpp_terminal_currency_1', $_POST['worldnet_hpp_terminal_currency_1']);
	update_option('worldnet_hpp_shared_secret_1', $_POST['worldnet_hpp_shared_secret_1']);
	
	if(isset($_POST['worldnet_hpp_send_email'])) update_option('worldnet_hpp_send_email', true);
	else update_option('worldnet_hpp_send_email', false);
	
	return true;
}

function gateway_worldnet_hpp($seperator, $sessionid) {
	global $wpdb, $wpsc_cart;
	
	$purchase_log = $wpdb->get_row("SELECT * FROM `" . WPSC_TABLE_PURCHASE_LOGS . "` WHERE `sessionid`= " . $sessionid . " LIMIT 1", ARRAY_A);
	
	$usersql = "SELECT `".WPSC_TABLE_SUBMITED_FORM_DATA."`.value, `".WPSC_TABLE_CHECKOUT_FORMS."`.`name`, `".WPSC_TABLE_CHECKOUT_FORMS."`.`unique_name` FROM `".WPSC_TABLE_CHECKOUT_FORMS."` LEFT JOIN `".WPSC_TABLE_SUBMITED_FORM_DATA."` ON `".WPSC_TABLE_CHECKOUT_FORMS."`.id = `".WPSC_TABLE_SUBMITED_FORM_DATA."`.`form_id` WHERE `".WPSC_TABLE_SUBMITED_FORM_DATA."`.`log_id`=".$purchase_log['id']." ORDER BY `".WPSC_TABLE_CHECKOUT_FORMS."`.`order`";
	$userinfo = $wpdb->get_results($usersql, ARRAY_A);
	
	$dateTime = date('d-m-Y:H:i:s:000');
	
	$receiptPageURL = get_option('transact_url') . $seperator . "sessionid=" . $sessionid . "&gateway=worldnet_hpp";
	
	$cartCurrency = $wpdb->get_var("SELECT `code` FROM `".WPSC_TABLE_CURRENCY_LIST."` WHERE `id`='".get_option('currency_type')."' LIMIT 1");
	switch($cartCurrency) {
		case get_option('worldnet_hpp_terminal_currency_1') :
			$terminalId = get_option('worldnet_hpp_terminal_id_1');
			$sharedSecret = get_option('worldnet_hpp_shared_secret_1');
			break;
		default :
			$terminalId = $currency_code[0]['code'];
			$sharedSecret = 'NOSECRET';
	}
	
	$data = array();
	$data['TERMINALID']		= $terminalId;
	$data['ORDERID']		= $purchase_log['id'];
	$data['CURRENCY'] 		= $cartCurrency;
	$data['AMOUNT']			= number_format($wpsc_cart->total_price,2);
	
	foreach((array)$userinfo as $key => $value) {
		if(($value['unique_name']=='billingemail') && $value['value'] != '' && get_option('worldnet_hpp_send_email')) $data['EMAIL'] = $value['value'];
		
		if(($value['unique_name']=='billingaddress') && $value['value'] != '') $data['ADDRESS1'] = $value['value'];
		if(($value['unique_name']=='billingcity') && $value['value'] != '') $data['ADDRESS2'] = $value['value'];
		if(($value['unique_name']=='billingpostcode') && $value['value'] != '') $data['POSTCODE'] = $value['value'];
		
		if(($value['unique_name']=='billingfirstname') && $value['value'] != '') $data['CARDHOLDERNAME'] .= $value['value'] . " ";
		if(($value['unique_name']=='billinglastname') && $value['value'] != '') $data['CARDHOLDERNAME'] .= $value['value'];
		if(($value['unique_name']=='billingphone') && $value['value'] != '') $data['BillingPhoneNumber'] = $value['value'];
		if(($value['unique_name']=='billingcountry') && $value['value'] != '') { $value['value'] = maybe_unserialize($value['value']); $data['BillingCountry'] = $value['value'][0]; }
		
		foreach($wpsc_cart->cart_items as $i => $Item) {
			$data['CartItem'.$i] = "Name: ".$Item->product_name."<br />";
			$data['CartItem'.$i] .= "Price: ".number_format($Item->unit_price,2)."<br />";
			$data['CartItem'.$i] .= "Quantity: ".$Item->quantity;
		}
	}
	$data['DATETIME']		= $dateTime;
	$data['RECEIPTPAGEURL']		= $receiptPageURL;
	$data['HASH']			= md5($terminalId . $purchase_log['id'] . number_format($wpsc_cart->total_price,2) . $dateTime . $receiptPageURL . $sharedSecret);
	$data['WORDPRESSSESSIONID']	= $sessionid;
	
	$worldnetURL = "https://" . (get_option('worldnet_hpp_test_account') ? "test" : "") . get_option('worldnet_hpp_gateway') . ".worldnettps.com/merchant/paymentpage";
	
	echo "<div style='display: none'>\n<form id='worldnet_hpp_form' action='$worldnetURL' method='get'>\n";
	foreach($data as $key => $val) echo "<input type='hidden' name='$key' value='$val' />\n";
	echo "<input type='submit' value='Pay' /></form>\n</div>\n<script language='javascript' type='text/javascript'>document.getElementById('worldnet_hpp_form').submit();</script>";
	
	exit();
}

function catch_worldnet_hpp() {
	global $wpdb;
	if($_GET['gateway'] == 'worldnet_hpp' && isset($_GET['WORDPRESSSESSIONID']) && $_GET['WORDPRESSSESSIONID'] != "") {
		switch($_GET['TERMINALID']) {
			case get_option('worldnet_hpp_terminal_id_1') :
				$sharedSecret = get_option('worldnet_hpp_shared_secret_1');
				break;
			default :
				$sharedSecret = '';
		}
		$expectedResponseHash = md5($_GET['TERMINALID'] . $_GET['ORDERID'] . $_GET['AMOUNT'] . $_GET['DATETIME'] . $_GET['RESPONSECODE'] . $_GET['RESPONSETEXT'] . $sharedSecret);
		
        	if($expectedResponseHash != $_GET['HASH']) {
			$wpdb->query("UPDATE `" . WPSC_TABLE_PURCHASE_LOGS . "` SET `processed` = '1' WHERE `sessionid` = " . $_GET['WORDPRESSSESSIONID']);
		} else {
			if($_GET['RESPONSECODE'] == 'A') {
				$wpdb->query("UPDATE `" . WPSC_TABLE_PURCHASE_LOGS . "` SET `processed` = '2' WHERE `sessionid` = " . $_GET['WORDPRESSSESSIONID']);
				if(strstr(get_option('transact_url'), "?")) $next_url = get_option('transact_url') . "&sessionid=" . $_GET['WORDPRESSSESSIONID'];
				else $next_url = get_option('transact_url') . "?sessionid=" . $_GET['WORDPRESSSESSIONID'];
			} else $wpdb->query("DELETE FROM `" . WPSC_TABLE_PURCHASE_LOGS . "` WHERE `sessionid` = " . $_GET['WORDPRESSSESSIONID']);
		}
		if(isset($next_url)) {
			header("Location: " . $next_url);
			exit();
		}
   	}
}

add_action('init', 'catch_worldnet_hpp');

?>
